<!DOCTYPE html>
<html>

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.0.0/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>


</head>

<body>
    <div class="container-fluid">
        <div class="form-group">
            <h1 class="text-center">DANH SÁCH ĐƠN HÀNG</h1>
        </div>
        <div class="container jumbotron">
            <div class="col-12">
                <div class="row form-group">
                    <div class="col-sm-6">
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="status-order-select">Trạng thái order</label>
                            </div>
                            <div class="col-8">
                                <select id="status-order-select" class="form-control">
                                    <option value="none">-- Hãy chọn trạng thái đơn hàng --</option>
                                    <option value="open">Open</option>
                                    <option value="confirmed">Confirmed</option>
                                    <option value="Cancel">Cancel</option>
                                </select>
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-6">
                        <div class="row form-group">
                            <div class="col-4">
                                <label for="">Loại Pizza</label>
                            </div>
                            <div class="col-8">
                                <select id="pizza-select" class="form-control">
                                    <option value="none">-- Hãy chọn loại pizza--</option>
                                    <option value="seafood">Seafood</option>
                                    <option value="hawaii">Hawaii</option>
                                    <option value="bacon">Bacon</option>
                                </select>
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-12 text-center">
                        <button class="btn btn-primary w-25" id="btn-filter">Lọc</button>
                    </div>
                </div>
            </div>
        </div>


        <table id="course-table" class="bg-light table table-striped table-bordered table-hover">
            <thead>
                <tr>
                    <th>STT</th>
                    <th>Order ID</th>
                    <th>Kích cỡ combo</th>
                    <th>Loại Pizza</th>
                    <th>Nước uống</th>
                    <th>Thành tiền</th>
                    <th>Họ và tên</th>
                    <th>Số điện thoại</th>
                    <th>Trạng thái</th>
                    <th>Chi tiết</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
        <!-- modal thêm -->
        <div>
            <div id="detail-order-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="h5-modal-title">Order Detail</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            <form>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-dia-chi">Địa chỉ</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="inp-dia-chi" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-duong-kinh">Đường kính</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="inp-duong-kinh" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-email">Email</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="inp-email" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-giamGia">Giảm Giá</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="inp-giamGia" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-hoTen">Họ và tên</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="inp-hoTen" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-idLoaiNuocUong">Id Loại nước uống</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="inp-idLoaiNuocUong" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-idVourcher">Id voucher</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="inp-idVourcher" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-kichCo">Kích cỡ</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="inp-kichCo" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-loaiPizza">Loại Pizza</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <select id="inp-loaiPizza" class="form-control">
                                            <option value="none">-- Hãy chọn loại pizza--</option>
                                            <option value="seafood">Seafood</option>
                                            <option value="hawaii">Hawaii</option>
                                            <option value="bacon">Bacon</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-trangThai">Trạng thái</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <select class="form-control" id="inp-trangThai">
                                            <option value="none">-- Hãy chọn trạng thái đơn hàng --</option>
                                            <option value="open">Open</option>
                                            <option value="confirmed">Confirmed</option>
                                            <option value="cancel">Cancel</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-loiNhan">Lời nhắn</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="inp-loiNhan" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-ngayCapNhat">Ngày cập nhật</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="inp-ngayCapNhat" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-ngayTao">Ngày tạo</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="inp-ngayTao" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-orderId">Order Id</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="inp-orderId" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-salad">Salad</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="inp-salad" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-soDienThoai">Số điện thoại</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="inp-soDienThoai" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-soLuongNuoc">Số lượng nước</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="inp-soLuongNuoc" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-suon">Sườn</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="inp-suon" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="inp-thanhTien">Thành tiền</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="inp-thanhTien" class="form-control">
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-success" id="btn-confirm">Confirm</button>
                            <button class="btn btn-warning" id="btn-cancel" data-dismiss="modal">Cancel</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>




    </div>

</body>

<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";
    var gAllOrder = [];
    var gOrder = {};
    var gOrderId = "";
    var gId = "";
    const gOrderData = ["STT", "orderId", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "chitiet"];
    const gSTT = 0;
    const gORDER_ID_COL = 1;
    const gKICH_CO_COL = 2;
    const gLOAI_PIZZA_COL = 3;
    const gNUOC_UONG_COL = 4;
    const gTHANH_TIEN_COL = 5;
    const gHO_TEN_COL = 6;
    const gSDT_COL = 7;
    const gTRANG_THAI_COL = 8;
    const gCHI_TIET_COL = 9;
    var stt = 1;

    var gOrderTable = $("#course-table").DataTable({
        columns: [
            { data: gOrderData[gSTT] },
            { data: gOrderData[gORDER_ID_COL] },
            { data: gOrderData[gKICH_CO_COL] },
            { data: gOrderData[gLOAI_PIZZA_COL] },
            { data: gOrderData[gNUOC_UONG_COL] },
            { data: gOrderData[gTHANH_TIEN_COL] },
            { data: gOrderData[gHO_TEN_COL] },
            { data: gOrderData[gSDT_COL] },
            { data: gOrderData[gTRANG_THAI_COL] },
            { data: gOrderData[gCHI_TIET_COL] }
        ],
        columnDefs: [
            {
                targets: gSTT,
                className: "d-lg-none",
                render: function () {
                    return stt++
                }
            },
            {
                targets: gCHI_TIET_COL,
                defaultContent: `<i class="fa-solid fa-pen-to-square text-success btn-detail"data-toggle="tooltip" title="chi tiết"></i>`
            }
        ]
    })
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {
        // call api
        callApiGetAllOrder();
        // cập nhật bảng
        loadDataIntoTable(gAllOrder);
    })

    // hàm nhấn nút lọc
    $("#btn-filter").click(function () {
        var vDataFilter = {
            trangThai: "",
            loaiPizza: ""
        }
        // lấy dữ liệu từ ô select
        getDataOrderFilter(vDataFilter);
        // kiểm tra
        // lọc dữ liệu
        var vFilter = filterOrder(vDataFilter);
        // hiển thị ra bảng
        loadDataIntoTable(vFilter)

    })

    // hàm nhấn nút chi tiết
    $(document).on("click", ".btn-detail", function () {
        // lấy order id và id của order
        getOrderIdAndId(this);
        // call api lấy thông tin order
        callApiGetDataOrder();
        // hiện modal
        $("#detail-order-modal").modal("show");
    })

    // hàm nhấn nút confirm
    $("#btn-confirm").click(function () {
        var vOrderConfirm = {
            diaChi: "",
            duongKinh: "",
            email: "",
            giamGia: 0,
            hoTen: "",
            idLoaiNuocUong: "",
            idVourcher: "",
            kichCo: "",
            loaiPizza: "",
            loiNhan: "",
            ngayCapNhat: 0,
            ngayTao: 0,
            orderId: "",
            salad: "",
            soDienThoai: "",
            soLuongNuoc: 0,
            suon: 0,
            thanhTien: 0,
            trangThai: "confirmed",
        }
        // thu thập thông tin order update trạng thái
        getDataOrderByModal(vOrderConfirm);
        // kiểm tra thông tin
        var vValidateDataOrderConfirm = validateOrderUpdate(vOrderConfirm);
        // call api confirm order
        if (vValidateDataOrderConfirm) {
            // gọi api confirm order
            callApiUpdateOrder(vOrderConfirm);
            // call api lấy danh sách order mới
            callApiGetAllOrder()
            // cập nhật bảng
            loadDataIntoTable(gAllOrder)
            // ẩn modal
            $("#detail-order-modal").modal("hide");
        }
    })

    // hàm nhấn nút cancel
    $("#btn-cancel").click(function () {
        var vOrderCancel = {
            diaChi: "",
            duongKinh: "",
            email: "",
            giamGia: 0,
            hoTen: "",
            idLoaiNuocUong: "",
            idVourcher: "",
            kichCo: "",
            loaiPizza: "",
            loiNhan: "",
            ngayCapNhat: 0,
            ngayTao: 0,
            orderId: "",
            salad: "",
            soDienThoai: "",
            soLuongNuoc: 0,
            suon: 0,
            thanhTien: 0,
            trangThai: "Cancel",
        }
        // thu thập thông tin order update trạng thái
        getDataOrderByModal(vOrderCancel);
        // kiểm tra thông tin
        var vValidateDataOrderCancel = validateOrderUpdate(vOrderCancel);
        // call api confirm order
        if (vValidateDataOrderCancel) {
            // gọi api confirm order
            callApiUpdateOrder(vOrderCancel);
            // call api lấy danh sách order mới
            callApiGetAllOrder()
            // cập nhật bảng
            loadDataIntoTable(gAllOrder)
            // ẩn modal
            $("#detail-order-modal").modal("hide");
        }
    })



    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // call api get all order
    function callApiGetAllOrder() {
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            async: false,
            success: function (res) {
                gAllOrder = res
            },
            error: function () {
                console.log(res.status)
            }
        })
    }
    // hàm hiện thông tin lên bảng
    function loadDataIntoTable(paramCourse) {
        // debugger;
        gOrderTable.clear();
        gOrderTable.rows.add(paramCourse);
        gOrderTable.draw();
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm lấy thông tin từ ô select
    function getDataOrderFilter(paramDataFilter) {
        paramDataFilter.trangThai = $("#status-order-select").val();
        paramDataFilter.loaiPizza = $("#pizza-select").val();
        console.log(paramDataFilter)
    }
    // lọc dữ liệu
    function filterOrder(paramDataFilter) {
        var vOrderFilter = [];
        vOrderFilter = gAllOrder.filter(function (paramOrder) {
            if (paramOrder.trangThai != null && paramOrder.loaiPizza != null) {
                // debugger;
                return ((paramOrder.trangThai.includes(paramDataFilter.trangThai) || paramDataFilter.trangThai == "none")
                    && (paramOrder.loaiPizza.includes(paramDataFilter.loaiPizza) || paramDataFilter.loaiPizza == "none"));
            }
        });
        return vOrderFilter;
    }
    // lấy order id và id của order
    function getOrderIdAndId(paramOrder) {
        var vCourseChange = gOrderTable.row($(paramOrder).parents("tr")).data();
        gOrderId = vCourseChange.orderId
        gId = vCourseChange.id
        console.log("orderID: " + gOrderId);
        console.log("ID: " + gId);
    }
    // call api lấy thông tin order
    function callApiGetDataOrder() {
        $.ajax({
            url: gBASE_URL + "/" + gOrderId,
            type: "GET",
            success: function (res) {
                console.log(res)
                gOrder = res;
                // hiển thị thông tin lên modal
                showDataOrderDetailToModal(res);
            },
            error: function (res) {
                console.log(res.status);
            }
        })
    }
    // hiển thị thông tin lên modal
    function showDataOrderDetailToModal(paramOrderDetail) {
        $("#inp-dia-chi").val(paramOrderDetail.diaChi);
        $("#inp-duong-kinh").val(paramOrderDetail.duongKinh);
        $("#inp-email").val(paramOrderDetail.email);
        $("#inp-giamGia").val(paramOrderDetail.giamGia);
        $("#inp-hoTen").val(paramOrderDetail.hoTen);
        $("#inp-idLoaiNuocUong").val(paramOrderDetail.idLoaiNuocUong);
        $("#inp-idVourcher").val(paramOrderDetail.idVourcher);
        $("#inp-kichCo").val(paramOrderDetail.kichCo);
        $("#inp-loaiPizza").val(paramOrderDetail.loaiPizza);
        $("#inp-trangThai").val(paramOrderDetail.trangThai);
        $("#inp-loiNhan").val(paramOrderDetail.loiNhan);
        $("#inp-ngayCapNhat").val((paramOrderDetail.ngayCapNhat));
        $("#inp-ngayTao").val((paramOrderDetail.ngayTao));
        $("#inp-orderId").val(paramOrderDetail.orderId);
        $("#inp-salad").val(paramOrderDetail.salad);
        $("#inp-soDienThoai").val(paramOrderDetail.soDienThoai);
        $("#inp-soLuongNuoc").val(paramOrderDetail.soLuongNuoc);
        $("#inp-suon").val(paramOrderDetail.suon);
        $("#inp-thanhTien").val(paramOrderDetail.thanhTien);
    }
    // hàm lấy thông tin order dựa vào modal
    function getDataOrderByModal(paramOrderConfirm) {
        paramOrderConfirm.diaChi = $("#inp-dia-chi").val().trim();
        paramOrderConfirm.duongKinh = $("#inp-duong-kinh").val().trim();
        paramOrderConfirm.email = $("#inp-email").val().trim();
        paramOrderConfirm.giamGia = $("#inp-giamGia").val().trim();
        paramOrderConfirm.hoTen = $("#inp-hoTen").val().trim();
        paramOrderConfirm.idLoaiNuocUong = $("#inp-idLoaiNuocUong").val().trim();
        paramOrderConfirm.idVourcher = $("#inp-idVourcher").val().trim();
        paramOrderConfirm.kichCo = $("#inp-kichCo").val().trim();
        paramOrderConfirm.loaiPizza = $("#inp-loaiPizza").val();
        paramOrderConfirm.loiNhan = $("#inp-loiNhan").val().trim();
        paramOrderConfirm.ngayCapNhat = $("#inp-ngayCapNhat").val().trim();
        paramOrderConfirm.ngayTao = $("#inp-ngayTao").val().trim();
        paramOrderConfirm.orderId = $("#inp-orderId").val().trim();
        paramOrderConfirm.salad = $("#inp-salad").val().trim();
        paramOrderConfirm.soDienThoai = $("#inp-soDienThoai").val().trim();
        paramOrderConfirm.soLuongNuoc = $("#inp-soLuongNuoc").val().trim();
        paramOrderConfirm.suon = $("#inp-suon").val().trim();
        paramOrderConfirm.thanhTien = $("#inp-thanhTien").val().trim();
    }
    // hàm kiểm tra thông tin trước khi confirm order
    function validateOrderUpdate(paramOrderConfirm) {
        console.log(paramOrderConfirm)

        if (paramOrderConfirm.diaChi == "") {
            alert("hãy nhập địa chỉ!");
            return false;
        }
        if (paramOrderConfirm.duongKinh == "") {
            alert("hãy nhập đường kính bánh!");
            return false;
        }
        if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(paramOrderConfirm.email)) {
        } else {
            alert("hãy nhập emaill đúng!")
            return false;
        }
        if (paramOrderConfirm.giamGia == "") {
            alert("hãy nhập giá giảm!");
            return false;
        }
        if (paramOrderConfirm.hoTen == "") {
            alert("hãy nhập họ và tên!");
            return false;
        }
        if (paramOrderConfirm.idLoaiNuocUong == "") {
            alert("hãy nhập id loại nước uống!");
            return false;
        }
        if (paramOrderConfirm.kichCo == "") {
            alert("hãy nhập kích cỡ!");
            return false;
        }
        if (paramOrderConfirm.loaiPizza == "") {
            alert("hãy nhập chọn loại pizza!");
            return false;
        }
        if (paramOrderConfirm.orderId == "") {
            alert("hãy nhập orderid!");
            return false;
        }
        if (paramOrderConfirm.salad == "") {
            alert("hãy nhập salad!");
            return false;
        }
        if (paramOrderConfirm.soDienThoai == "") {
            alert("hãy nhập số điện thoại!");
            return false;
        }
        if (paramOrderConfirm.soLuongNuoc == "") {
            alert("hãy nhập số lượng nước!");
            return false;
        }
        if (paramOrderConfirm.suon == "") {
            alert("hãy nhập số lượng sườn nướng!");
            return false;
        }
        if (paramOrderConfirm.thanhTien == "") {
            alert("hãy nhập số tiền!");
            return false;
        }
        return true
    }
    // call api confirm order
    function callApiUpdateOrder(paramOrder) {
        console.log(paramOrder);
        $.ajax({
            url: gBASE_URL + "/" + gId,
            type: "PUT",
            async: false,
            contentType: "application/json",
            data: JSON.stringify(paramOrder),
            success: function (res) {
                console.log(res);
            },
            error: function (res) {
                console.log(res.status);
            }
        })
    }

</script>

</html>